i2c_start equ $083C
i2c_write equ $0846
i2c_read  equ $086F
i2c_readlast equ $08BB
i2c_stop  equ $08E5
PCFD      equ 78
PCFDr     equ 79
PCFA      equ 76
PCFAr     equ 77
SAA       equ $70
Control   equ $a1 ; Control-Register und I/O-Ports (= Basic-Byte 1)
              ;RAM-Dev.HS:<LSB> bit16,CS0,1,Port A,B ,#0, Port C,D <MSB>
          ;RAM-Interf.IC:<LSB> bit16,CS0,1,2,3 ,#0, Port A,B <MSB>

; 91,92 = Wert; 93,94 = 16bit Addr(bit0 bis bit15)

        org $101
readports  ; Portzustnde des Adress-PCF in Basic-Byte 1 speichern
        bsr rdlast
        ldx #PCFAr
        bsr rdb
        lda $92
        sta Control
        bra coneeprom

writew  bsr rdlast ; Word schreiben
        bsr writeRAM
        bclr 0,$94 ; Bit inv.setzen fr lo-word-Adresse
        bra NBw

writeb  bsr rdlast ; Byte schreiben
NBw     lda $92
        sta $91
        bsr writeRAM
        bra coneeprom

readb   bsr readmod ; Byte lesen
        clr $91
        bra coneeprom

readw   bsr readmod ; Word lesen
        bclr 0,$94 ; Bit inv.setzen fr lo-word-Adresse
        lda $92
        sta $91
        bsr readRAM
coneeprom 
        ldx #$0A0
        bsr i2cstart
        ldx $066
        jsr i2c_write
        ldx $067
        jsr i2c_write
        ldx #$0A1
i2cstart
        jsr i2c_start
        rts
       
readmod bsr rdlast ; Data-PCF8574 als Eingang
        ldx #PCFD
        bsr i2cstart
        ldx #$FF
        bsr wrlast
readRAM
        bsr setaddr
setAR   ldx #PCFA
        bsr i2cstart
        bsr sWaR
        ldx #PCFDr
rdb     bsr i2cstart
        jsr i2c_read
        sta $92
rdlast  jsr i2c_readlast
        rts

writeRAM
        ldx #PCFD
        bsr i2cstart
        ldx $91
        bsr wrlast
        bsr setaddr
setAW   ldx #PCFA
        bsr i2cstart
        lda Control
        and #$DF
        tax
        jsr i2c_write
sWaR    lda Control
        ora #$20
        tax
        bra wrlast

setaddr ldx #SAA
        jsr i2c_start
        ldx #1
SAAprt  jsr i2c_write
        ldx $93
        jsr i2c_write
        ldx $94
wrlast  jsr i2c_write
        jsr i2c_stop
        rts

SAAinit bsr rdlast ; SAA1064 initialisieren
        ldx #SAA
        bsr i2cstart
        ldx #0
        jsr i2c_write
        ldx #$40
        bsr SAAprt
        bra coneeprom

        
